// Generated by CoffeeScript 1.12.7
var datasetTarget, field, modsToRadio;

datasetTarget = '';

field = '';

modsToRadio = function(mods) {
  var author, date, edition, extent, id, place, publisher, title;
  id = $(mods).find('recordInfo > recordIdentifier').text().trim();
  author = '';
  $(mods).children('name[usage="primary"]').each(function() {
    if ($(this).children('namePart:not([type])').length) {
      return author += $(this).children('namePart:not([type])').text().trim() + '. ';
    } else {
      author += $(this).children('namePart[type="given"]').text().trim() + ' ';
      return author += $(this).children('namePart[type="family"]').text().trim() + '. ';
    }
  });
  title = '';
  $(mods).find('titleInfo > *').each(function() {
    return title += $(this).text().trim() + '. ';
  });
  edition = '';
  $(mods).find('originInfo > edition').each(function() {
    return edition += $(this).text().trim() + '. ';
  });
  place = '';
  $(mods).find('originInfo placeTerm[type="text"]').each(function() {
    return place += $(this).text().trim() + '. ';
  });
  date = '';
  $(mods).find('originInfo > dateIssued').each(function() {
    return date += $(this).text().trim() + '. ';
  });
  extent = '';
  $(mods).find('physicalDescription > extent').each(function() {
    return extent += $(this).text().trim() + '. ';
  });
  publisher = '';
  $(mods).find('originInfo > publisher').each(function() {
    return publisher += $(this).text().trim() + '. ';
  });
  return '<div class="radio"> <label> <input type="radio" name="dataset-radios" value="' + id + '"> <strong>' + author + '</strong> <span class="title">' + title + '</span> <span class="edition">' + edition + '</span> <span class="place">' + place + '</span> <span class="date">' + date + '</span> <span class="extent hidden">' + extent + '</span> <span class="publisher hidden">' + publisher + '</span> </label> </div>';
};

$('div#content').on('click', 'div.owl\\:sameAs button', function() {
  field = $(this).closest('div.form-group');
  return $('div#dataset-modal').modal('show');
});

$('ul#dataset-target-menu a').click(function(e) {
  var $this;
  e.preventDefault();
  $this = $(this);
  datasetTarget = $this.attr('id');
  $('button#dataset-target-button').html($this.text() + ' ' + caret);
  $('input#dataset-search-input').prop('disabled', false);
  $('button#dataset-search-button').prop('disabled', false);
  return $('div#dataset-results').empty();
});

$('a#bvb, a#vd18').click(function(e) {
  e.preventDefault();
  $('input#dataset-search-input').prop('disabled', true);
  $('button#dataset-search-button').prop('disabled', true);
  return $('div#dataset-results').html('<input type="text" class="form-control"></input>');
});

$('button#dataset-search-button').click(function(e) {
  var $this, keyword, request;
  e.preventDefault();
  $this = $(this);
  $this.button('loading');
  $('div#dataset-results').empty();
  if (datasetTarget === '') {
    $('div#dataset-results').html('<p class="help-block">Bitte Suchziel wählen!</p>');
    $this.button('reset');
  }
  if (datasetTarget === 'ct') {
    keyword = $('input#dataset-search-input').val();
    request = {
      'operation': 'searchRetrieve',
      'query': 'ct.personalName=' + keyword,
      'version': 1.1
    };
    $.ajax({
      type: 'GET',
      url: 'http://sru.cerl.org/thesaurus',
      data: request
    }).done(function(data) {
      var results;
      results = $(data).find('srw\\:recordData, recordData');
      $(results).each(function(key, value) {
        var bio, id, name;
        id = $(value).find('record').attr('id');
        name = $(value).find('display').text();
        bio = $(value).find('biographicalData').text();
        return $('div#dataset-results').append('<div class="radio"> <label> <input type="radio" name="dataset-radios" value="' + id + '"> <strong>' + name + ':</strong> ' + bio + '</label> </div>');
      });
      return $this.button('reset');
    });
  }
  if (datasetTarget === 'dnb') {
    keyword = encodeURIComponent($('input#dataset-search-input').val());
    $.ajax({
      type: 'GET',
      url: 'http://ref.dariah.eu/beta/pndsearch/pndquery.xql?ln=' + keyword
    }).done(function(data) {
      var results;
      results = $(data).find('person');
      return $(results).each(function(key, value) {
        var id, info, name;
        id = $(value).attr('id');
        name = $(value).find('preferred_name').text();
        info = $(value).find('info').text();
        if ($('div#dataset-results input[value="' + id + '"]').length) {
          return true;
        }
        $('div#dataset-results').append('<div class="radio"> <label> <input type="radio" name="dataset-radios" value="' + id + '"> <strong>' + name + ':</strong> ' + info + '</label> </div>');
        return $this.button('reset');
      });
    });
  }
  if (datasetTarget === 'gvk') {
    keyword = $('input#dataset-search-input').val();
    request = {
      'maximumRecords': 999,
      'operation': 'searchRetrieve',
      'query': keyword,
      'recordSchema': 'mods',
      'version': 1.1
    };
    $.ajax({
      type: 'GET',
      url: 'http://sru.gbv.de/gvk',
      data: request
    }).done(function(data) {
      var results;
      $this.button('reset');
      results = $(data).find('mods');
      return $(results).each(function(key, value) {
        return $('div#dataset-results').append(modsToRadio(value));
      });
    });
  }
  if (datasetTarget === 'swb') {
    keyword = $('input#dataset-search-input').val();
    return $.ajax({
      type: 'GET',
      url: 'http://localhost:9090/db/swb?query=' + keyword
    }).done(function(data) {
      var results;
      $this.button('reset');
      results = $(data).find('mods');
      return $(results).each(function(key, value) {
        return $('div#dataset-results').append(modsToRadio(value));
      });
    });
  }
});

$('button#dataset-set').click(function(e) {
  var date, edition, extent, firstName, id, input, lastName, place, publisher, strong, url;
  e.preventDefault();
  input = $('div#dataset-results input[name="dataset-radios"]:checked');
  if (datasetTarget === 'bvb') {
    id = $('div#dataset-results input').val();
    $.ajax({
      type: 'GET',
      url: 'http://lod.b3kat.de/data/title/' + id + '?output=xml'
    }).done(function(data) {
      var date, edition, extent, publication, responsibility;
      field.find('span.value').text('bvb:' + id);
      field.find('span.value').wrap('<a href="' + tgf.getPrefixes()['bvb'] + id + '" target="_blank"></a>');
      edition = $(data).find('bibo\\:edition, edition').text().trim();
      extent = $(data).find('dcterms\\:extent, extent').text().trim();
      responsibility = $(data).find('dcterms\\:description, description').text().trim();
      publication = $(data).find('rdagr1\\:publicationStatement, publicationStatement').text().trim();
      date = $(data).find('dcterms\\:issued, issued').text().trim();
      $('div.bf\\:edition input').val(edition);
      $('div.dct\\:extent input').val(extent);
      $('div.bf\\:providerStatement input').val(responsibility);
      $('div.bf\\:responsibilityStatement input').val(publication);
      return $('div.dc\\:date input').val(date);
    });
  }
  if (input.length && datasetTarget === 'ct') {
    field.find('span.value').text('ct:' + input.val());
    field.find('span.value').wrap('<a href="' + tgf.getPrefixes()['ct'] + input.val() + '" target="_blank"></a>');
  }
  if (input.length && datasetTarget === 'dnb') {
    field.find('span.value').text(input.val());
    field.find('span.value').wrap('<a href="' + tgf.getPrefixes()['dnb'] + input.val().replace(/^pnd:/, '') + '" target="_blank"></a>');
  }
  if (input.length && (datasetTarget === 'ct' || datasetTarget === 'dnb')) {
    strong = input.closest('label').children('strong');
    firstName = strong.text().replace(/^.*, /, '').replace(/:$/, '');
    lastName = strong.text().replace(/,.*$/, '');
    $('div.foaf\\:name input').val(firstName + ' ' + lastName);
  }
  if (input.length && datasetTarget === 'gvk') {
    field.find('span.value').text('gvk:' + input.val());
    field.find('span.value').wrap('<a href="' + tgf.getPrefixes()['gvk'] + input.val() + '" target="_blank"></a>');
  }
  if (input.length && datasetTarget === 'swb') {
    field.find('span.value').text('swb:' + input.val());
    field.find('span.value').wrap('<a href="' + tgf.getPrefixes()['swb'] + input.val() + '" target="_blank"></a>');
  }
  if (input.length && (datasetTarget === 'gvk' || datasetTarget === 'swb')) {
    edition = input.closest('label').children('span.edition').text().replace(/. $/, '');
    extent = input.closest('label').children('span.extent').text().replace(/. $/, '');
    place = input.closest('label').children('span.place').text().replace(/. $/, '');
    date = input.closest('label').children('span.date').text().replace(/. $/, '');
    publisher = input.closest('label').children('span.publisher').text().replace(/. $/, '');
    $('div.bf\\:edition input').val(edition);
    $('div.dct\\:extent input').val(extent);
    $('div.bf\\:providerStatement input').val(place + ' ' + date);
    $('div.bf\\:responsibilityStatement input').val(publisher + ' (Hrsg.)');
    $('div.dc\\:date input').val(date);
  }
  if (datasetTarget === 'vd18') {
    url = $('div#dataset-results input').val();
    field.find('span.value').html('<a href="' + url + '" target="_blank">' + url + '</a>');
  }
  return $('div#dataset-modal').modal('hide');
});

$('div#content').on('click', 'div.dct\\:creator button, div.dct\\:publisher button', function() {
  field = $(this).closest('div.form-group');
  return $('div#person-modal').modal('show');
});

$('button#person-search-button').click(function(e) {
  var $this, keyword, request;
  e.preventDefault();
  $this = $(this);
  $this.button('loading');
  $('div#person-results').empty();
  keyword = $('input#person-search-input').val();
  request = {
    'output': 'json',
    'query': 'PREFIX foaf: <http://xmlns.com/foaf/0.1/> \n SELECT ?g ?o \n { \n GRAPH ?g \n { \n ?s foaf:name ?o . \n FILTER regex(?o, \n replace("' + keyword + '", " ", ".*"), \n "i") \n } \n }'
  };
  return $.ajax({
    type: 'GET',
    url: 'http://localhost:3030/ds/query',
    cache: false,
    data: request
  }).done(function(data) {
    var i, id, len, name, result, results;
    results = data['results']['bindings'];
    for (i = 0, len = results.length; i < len; i++) {
      result = results[i];
      id = result['g']['value'];
      name = result['o']['value'];
      $('div#person-results').append('<div class="radio"> <label> <input type="radio" name="person-radios" value="' + id + '"> <strong>' + name + '</strong> </label> </div>');
    }
    return $this.button('reset');
  });
});

$('button#person-set').click(function(e) {
  var id, name;
  e.preventDefault();
  id = $('div#person-results input[name="person-radios"]:checked').val();
  name = $('div#person-results input[value="' + id + '"] + strong').text();
  if (id) {
    field.find('span.value + span').remove();
    field.find('span.value').text(id).after('<span>[ ' + name + ' ]</name>');
  }
  return $('div#person-modal').modal('hide');
});

$('div#birth-form').on('click', 'div.bio\\:place button', function() {
  field = $(this).closest('div.form-group');
  return $('div#place-modal').modal('show');
});

$('div#death-form').on('click', 'div.bio\\:place button', function() {
  field = $(this).closest('div.form-group');
  return $('div#place-modal').modal('show');
});

$('button#place-search-button').click(function(e) {
  var $this, keyword;
  e.preventDefault();
  $this = $(this);
  $this.button('loading');
  $('div#place-results').empty();
  keyword = encodeURIComponent($('input#place-search-input').val());
  return $.ajax({
    type: 'GET',
    url: 'http://geobrowser.de.dariah.eu/tgnsearch/tgnquery2.xql?ac=' + keyword
  }).done(function(data) {
    var results;
    results = $(data).find('term');
    $(results).each(function(key, value) {
      var id, name, path;
      id = $(value).attr('id');
      name = $(value).find('name').text();
      path = $(value).find('path').text();
      return $('div#place-results').append('<div class="radio"> <label> <input type="radio" name="place-radios" value="' + id + '"> <strong>' + name + ':</strong> ' + path + '</label> </div>');
    });
    return $this.button('reset');
  });
});

$('button#place-set').click(function(e) {
  var id;
  e.preventDefault();
  id = $('div#place-results input[name="place-radios"]:checked').val();
  if (id) {
    field.find('span.value').text(id);
    field.find('span.value').wrap('<a href="' + tgf.getPrefixes()['tgn'] + id.replace(/^tgn:/, '') + '" target="_blank"></a>');
  }
  return $('div#place-modal').modal('hide');
});

$('div#content').on('click', 'div.bf\\:instanceOf button', function() {
  field = $(this).closest('div.form-group');
  return $('div#work-modal').modal('show');
});

$('button#work-search-button').click(function(e) {
  var $this, keyword, request;
  e.preventDefault();
  $this = $(this);
  $this.button('loading');
  $('div#work-results').empty();
  keyword = $('input#work-search-input').val();
  request = {
    'output': 'json',
    'query': 'PREFIX bf: <http://bibframe.org/vocab/> \n PREFIX dc: <http://purl.org/dc/elements/1.1/> \n SELECT ?g ?o \n { \n GRAPH ?g \n { \n ?s a bf:Work . \n ?s dc:title ?o . \n FILTER regex(?o, \n replace("' + keyword + '", " ", ".*"), \n "i") \n } \n }'
  };
  return $.ajax({
    type: 'GET',
    url: 'http://localhost:3030/ds/query',
    cache: false,
    data: request
  }).done(function(data) {
    var i, id, len, result, results, title;
    results = data['results']['bindings'];
    for (i = 0, len = results.length; i < len; i++) {
      result = results[i];
      id = result['g']['value'];
      title = result['o']['value'];
      $('div#work-results').append('<div class="radio"> <label> <input type="radio" name="work-radios" value="' + id + '"> <strong>' + title + '</strong> </label> </div>');
    }
    return $this.button('reset');
  });
});

$('button#work-set').click(function(e) {
  var id, title;
  e.preventDefault();
  id = $('div#work-results input[name="work-radios"]:checked').val();
  title = $('div#work-results input[value="' + id + '"] + strong').text();
  if (id) {
    field.find('span.value + span').remove();
    field.find('span.value').text(id).after('<span>[ ' + title + ' ]</span>');
  }
  return $('div#work-modal').modal('hide');
});
